declare const _exports: {
    "name": string;
    "version": string;
    "description": string;
    "main": string;
    "types": string;
    "repository": {
        "type": string;
        "url": string;
    };
    "engines": {
        "node": string;
        "npm": string;
    };
    "engineStrict": boolean;
    "author": string;
    "contributors": string[];
    "scripts": {
        "lint": string;
        "lint:fix": string;
        "check": string;
        "build": string;
        "test": string;
        "prepare": string;
    };
    "license": string;
    "dependencies": {
        "basic-auth-parser": string;
        "eventemitter3": string;
    };
    "devDependencies": {
        "@types/chai": string;
        "@types/mocha": string;
        "@types/node": string;
        "@types/request-promise": string;
        "chai": string;
        "husky": string;
        "lint-staged": string;
        "mocha": string;
        "request": string;
        "request-promise": string;
        "resin-lint": string;
        "ts-node": string;
        "typescript": string;
    };
    "husky": {
        "hooks": {
            "pre-commit": string;
            "pre-push": string;
        };
    };
    "lint-staged": {
        "*.ts": string[];
    };
};
export = _exports;
